Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.data
Class AbleTypedVariableCompoundLiteral

    java.lang.Object
      com.ibm.able.data.AbleLiteral
          com.ibm.able.data.AbleTypedVariableCompoundLiteral

All Implemented Interfaces:
  AbleRd, java.io.Serializable

public class AbleTypedVariableCompoundLiteral
extends AbleLiteral

This class performs a sequence of field access and method invocations starting on an AbleTypedVariable. This literal behaves somewhat differently from other AbleLiterals, in that is not strictly a constant, it invokes the same methods on the same typed variable, but the underlying Object being invoked may change during the course of a ruleset evaluation.

Any nested dot notation field references or method calls get parsed and turned into an instance of this class. Any number of arguments may appear in the source statement.

See Also:
  Serialized Form

Field Summary
`protected java.util.Vector` | `myLiterals` The list of typed field and method literals.
`protected AbleTypedVariable` | `myTypedVariable` The typed variable to which this method belongs.

Constructor Summary
`AbleTypedVariableCompoundLiteral(AbleTypedVariableCompoundLiteral theLiteral, AbleTypedVariable theReplacementVariable, java.util.Vector theLiterals)` Create a copy of this method literal with replacement args
`AbleTypedVariableCompoundLiteral(AbleTypedVariable theTypedVariable, java.util.Vector theLiterals)` Create a new Able data method object with the specified information.

Method Summary
`java.lang.String` | `arlCRdString()` Return a formal ARL "clause read" string that describes this data object.
`AbleLiteral` | `bitwiseAND(AbleRd theRhs)` Bitwise AND the current value of this data object with the current value of theRhs.
`AbleLiteral` | `bitwiseNOT(AbleRd theRhs)` Bitwise NOT: unary complement of the current value of this data object.
`AbleLiteral` | `bitwiseOR(AbleRd theRhs)` Bitwise OR the current value of this data object with the current value of theRhs.
`AbleLiteral` | `bitwiseShiftLeft(AbleRd theRhs)` Bitwise Shift Left the current value of this data object by the current value of theRhs.
`AbleLiteral` | `bitwiseShiftRight(AbleRd theRhs)` Bitwise Shift Right the current value of this data object by the current value of theRhs.
`AbleLiteral` | `bitwiseShiftRightZeroFill(AbleRd theRhs)` Bitwise Shift Right with Zero Fill the current value of this data object by the current value of theRhs.
`AbleLiteral` | `bitwiseXOR(AbleRd theRhs)` Bitwise XOR: exclusive OR the current value of this data object with the current value of theRhs.
`boolean` | `cmpEq(AbleRd theRhs)` Comparison, equal to: compare the current value of this data object to the current value of theRhs.
`boolean` | `cmpGt(AbleRd theRhs)` Comparison, greater than: compare the current value of this data object to the current value of theRhs.
`boolean` | `cmpGtEq(AbleRd theRhs)` Comparison, greater than or equal to: compare the current value of this data object to the current value of theRhs.
`boolean` | `cmpLt(AbleRd theRhs)` Comparison, less than: compare the current value of this data object to the current value of theRhs.
`boolean` | `cmpLtEq(AbleRd theRhs)` Comparison, less than or equal to: compare the current value of this data object to the current value of theRhs.
`boolean` | `cmpNeq(AbleRd theRhs)` Comparison, not equal to: compare the current value of this data object to the current value of theRhs.
`AbleLiteral` | `compDivide(AbleRd theRhs)` Compute, divide the current value of this data object by the current value of theRhs.
`AbleLiteral` | `compMinus(AbleRd theRhs)` Compute, subtract the current value of theRhs from the current value of this object.
`AbleLiteral` | `compModulo(AbleRd theRhs)` Compute, modulo - divide (without remainder) the current int value of this data object by the current value of theRhs.
`AbleLiteral` | `compMultiply(AbleRd theRhs)` Compute, multiply the current value of this data object to the current value of theRhs.
`AbleLiteral` | `compPlus(AbleRd theRhs)` Compute, add or concatenate the current value of this data object to the current value of theRhs.
`AbleLiteral` | `createMatchLiteral(java.util.Hashtable replacementVars)` Create a duplicate of this method literal using replacement vars
`boolean` | `equals(java.lang.Object otherObject)`
`boolean` | `getBooleanValue()` Retrieve the value of this data object as a boolean value.
`int` | `getDataType()` Retrieve the data type of this data object.
`java.lang.Class` | `getDataTypeClass()` Retrieve the Class of the underlying return value; that is, the value returned by last field or method.
`java.lang.String` | `getDataTypeClassName()` Retrieve the Class name of the underlying return value; that is, the value returned by last field or method.
`AbleFuzzySet` | `getFuzzyValue()` Retrieve the value of this data object as a fuzzy value.
`java.lang.Object` | `getGenericValue()` Retrieve the value of this data object as an Object.
`java.util.Vector` | `getLiterals()` The list of literals that make up this compound literals
`double` | `getNumericValue()` Retrieve the value of this data object as a numeric value.
`java.util.BitSet` | `getReferents()` Retrieve the Ids of the variables to which this data object refers, if any.
`java.lang.Class` | `getReturnType()` Get the data type of the value returned from the associated method invocation.
`java.lang.String` | `getStringValue()` Retrieve the value of this data object as a string value.
`java.lang.String` | `getTemplateString(java.util.Vector theTemplateVars)` Retrieve a text format string for use by rule templates.
`AbleTypedVariable` | `getTypedVariable()` Retrieve the typed variable
`AbleLiteral` | `getValue()` Retrieve the value of this data object as a literal.
`java.util.HashSet` | `getVariableReferences()` Retrieve the set of variables (if any) referenced by this expression (and subexpressions)
`int` | `hashCode()`
`boolean` | `isConstant()` Returns true if this AbleRd object is a constant value false, if it does not.
`boolean` | `logicalAND(AbleRd theRhs)` Logical AND the current value of this data object with the current value of theRhs.
`boolean` | `logicalNOT(AbleRd theRhs)` Logical NOT: complement the current value of this data object.
`boolean` | `logicalOR(AbleRd theRhs)` Logical OR the current value of this data object with the current value of theRhs.
`java.lang.String` | `traceString(int theTraceStringFlavor)` Retrieve a string describing (the contents of) the object.
`protected java.lang.String` | `trcString(int theTraceStringFlavor)`
`java.lang.String` | `xmlCRdString()` Return a formal XML "clause read" string that describes this data object.
`protected java.lang.String` | `xmlCRdStringArgs(AbleTypedVariableCompoundLiteral theLit)`

Methods inherited from class com.ibm.able.data.AbleLiteral
`cmpIs, compUnaryMinus, getDataTypeAsString, getReferent, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### myTypedVariable

    protected AbleTypedVariable myTypedVariable

  The typed variable to which this method belongs.

  This field is initialized to null and changed by the constructor when a new typed variable method is created.

### myLiterals

    protected java.util.Vector myLiterals

  The list of typed field and method literals.

Constructor Detail

### AbleTypedVariableCompoundLiteral

    public AbleTypedVariableCompoundLiteral(AbleTypedVariable theTypedVariable,
                                            java.util.Vector theLiterals)
                                     throws AbleDataException

  Create a new Able data method object with the specified information. The initial value of this literal is null, and it remains null until this literal is requested to give up a value. At that time, the method is called to produce a value. Each time a value is requested from this literal, the method is recalled; be aware that the current value may thus change from time to time.

Parameters:
  `theTypedVariable` - A typed variable that contains the following field.

  `theLiterals` - A list of AbleRd objects whose runtime values will be passed to the user-defined function as arguments. Each converted argument will be a Boolean, a Double, a String, or an Object, depending on the type of each AbleRd object in the argument list. The list can be empty, but it must never be null.

### AbleTypedVariableCompoundLiteral

    public AbleTypedVariableCompoundLiteral(AbleTypedVariableCompoundLiteral theLiteral,
                                            AbleTypedVariable theReplacementVariable,
                                            java.util.Vector theLiterals)
                                     throws AbleDataException

  Create a copy of this method literal with replacement args

Method Detail

### createMatchLiteral

    public AbleLiteral createMatchLiteral(java.util.Hashtable replacementVars)

  Create a duplicate of this method literal using replacement vars

### arlCRdString

    public java.lang.String arlCRdString()

  Return a formal ARL "clause read" string that describes this data object.

  Specified by:
    `arlCRdString` in interface `AbleRd`
  Specified by:
    `arlCRdString` in class `AbleLiteral`
  Returns:
    A String describing the data object in formal rule language.

### xmlCRdString

    public java.lang.String xmlCRdString()

  Return a formal XML "clause read" string that describes this data object.

  Specified by:
    `xmlCRdString` in interface `AbleRd`
  Specified by:
    `xmlCRdString` in class `AbleLiteral`
  Returns:
    A String describing the data object in XML.

### xmlCRdStringArgs

    protected java.lang.String xmlCRdStringArgs(AbleTypedVariableCompoundLiteral theLit)

### getTemplateString

    public java.lang.String getTemplateString(java.util.Vector theTemplateVars)

  Retrieve a text format string for use by rule templates. The string contains "{n}" strings, where the index 'n' corresponds to the template variables defined in the rule template. This string is based on the standard arlString() representation of the rule. After replacement of the template variable values, the resulting string must be a valid ARL format string that can be parsed.

  Specified by:
    `getTemplateString` in interface `AbleRd`
  Overrides:
    `getTemplateString` in class `AbleLiteral`
  Parameters:
    `theTemplateVars` - An ordered list of template variables referenced by this rule.
  Returns:
    A Text format string used to create a new rule instance.

### getReferents

    public java.util.BitSet getReferents()

  Retrieve the Ids of the variables to which this data object refers, if any. Must be overriden by subclasses which can refer to variables.

  Specified by:
    `getReferents` in interface `AbleRd`
  Overrides:
    `getReferents` in class `AbleLiteral`
  Returns:
    The Ids of the variables to which this data object refers, or AbleData.VarIdNull if the data object is a literal and therefore refers to no variable.

### getBooleanValue

    public boolean getBooleanValue()
                            throws AbleDataException

  Retrieve the value of this data object as a boolean value.

  Specified by:
    `getBooleanValue` in interface `AbleRd`
  Specified by:
    `getBooleanValue` in class `AbleLiteral`
  Returns:
    A boolean, if the value of this object can be represented as a boolean value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a boolean value.

### getFuzzyValue

    public AbleFuzzySet getFuzzyValue()
                               throws AbleDataException

  Retrieve the value of this data object as a fuzzy value.

  Specified by:
    `getFuzzyValue` in interface `AbleRd`
  Specified by:
    `getFuzzyValue` in class `AbleLiteral`
  Returns:
    A fuzzy set, if the value of this object can be represented as a fuzzy value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a fuzzy value.

### getGenericValue

    public java.lang.Object getGenericValue()
                                     throws AbleDataException

  Retrieve the value of this data object as an Object.

  Specified by:
    `getGenericValue` in interface `AbleRd`
  Specified by:
    `getGenericValue` in class `AbleLiteral`
  Returns:
    An Object of some sort depending on the sequence of field and method literals used. This method returns the result of the last field referenced or the last method called.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as an Object.

### getNumericValue

    public double getNumericValue()
                           throws AbleDataException

  Retrieve the value of this data object as a numeric value.

  Specified by:
    `getNumericValue` in interface `AbleRd`
  Specified by:
    `getNumericValue` in class `AbleLiteral`
  Returns:
    A double, if the value of this object can be represented as a numeric value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a numeric value.

### getStringValue

    public java.lang.String getStringValue()
                                    throws AbleDataException

  Retrieve the value of this data object as a string value.

  Specified by:
    `getStringValue` in interface `AbleRd`
  Specified by:
    `getStringValue` in class `AbleLiteral`
  Returns:
    A String, if the value of this object can be represented as a string value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a string value.

### getValue

    public AbleLiteral getValue()
                         throws AbleDataException

  Retrieve the value of this data object as a literal.

  Specified by:
    `getValue` in interface `AbleRd`
  Specified by:
    `getValue` in class `AbleLiteral`
  Returns:
    An AbleLiteral object.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a literal.

### cmpEq

    public boolean cmpEq(AbleRd theRhs)
                  throws AbleDataException

  Comparison, equal to: compare the current value of this data object to the current value of theRhs.

  "==" is used for numeric and boolean compares; equals() is used for Object compares; and equals() is used for String compares.

  Specified by:
    `cmpEq` in interface `AbleRd`
  Overrides:
    `cmpEq` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is equal to theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### cmpGt

    public boolean cmpGt(AbleRd theRhs)
                  throws AbleDataException

  Comparison, greater than: compare the current value of this data object to the current value of theRhs.

  ">" is used for numeric compares; Collator.compare() is used for String compares. Use of other data types on the left-hand side causes an exception.

  Specified by:
    `cmpGt` in interface `AbleRd`
  Overrides:
    `cmpGt` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is greater than theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### cmpGtEq

    public boolean cmpGtEq(AbleRd theRhs)
                    throws AbleDataException

  Comparison, greater than or equal to: compare the current value of this data object to the current value of theRhs.

  ">=" is used for numeric compares; Collator.compare() is used for String compares. Use of other data types on the left-hand side causes an exception.

  Specified by:
    `cmpGtEq` in interface `AbleRd`
  Overrides:
    `cmpGtEq` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is greater than or equal to theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### cmpLt

    public boolean cmpLt(AbleRd theRhs)
                  throws AbleDataException

  Comparison, less than: compare the current value of this data object to the current value of theRhs.

  "<" is used for numeric compares; Collator.compare() is used for String compares. Use of other data types on the left-hand side causes an exception.

  Specified by:
    `cmpLt` in interface `AbleRd`
  Overrides:
    `cmpLt` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is less than theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### cmpLtEq

    public boolean cmpLtEq(AbleRd theRhs)
                    throws AbleDataException

  Comparison, less than or equal to: compare the current value of this data object to the current value of theRhs.

  "<=" is used for numeric compares; Collator.compare() is used for String compares. Use of other data types on the left-hand side causes an exception.

  Specified by:
    `cmpLtEq` in interface `AbleRd`
  Overrides:
    `cmpLtEq` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is less than or equal to theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### cmpNeq

    public boolean cmpNeq(AbleRd theRhs)
                   throws AbleDataException

  Comparison, not equal to: compare the current value of this data object to the current value of theRhs.

  "!=" is used for numeric and boolean compares; ! equals() is used for Object compares; and ! Collator.equals() is used for String compares.

  Specified by:
    `cmpNeq` in interface `AbleRd`
  Overrides:
    `cmpNeq` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    true, if this data object is not equal to theRhs; false, otherwise.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### compPlus

    public AbleLiteral compPlus(AbleRd theRhs)
                         throws AbleDataException

  Compute, add or concatenate the current value of this data object to the current value of theRhs.

  "+" is used for numeric addtion and String concatenation.

  Specified by:
    `compPlus` in interface `AbleRd`
  Overrides:
    `compPlus` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the addition or concatenation operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### compMinus

    public AbleLiteral compMinus(AbleRd theRhs)
                          throws AbleDataException

  Compute, subtract the current value of theRhs from the current value of this object.

  "-" is used for numeric subtraction.

  Specified by:
    `compMinus` in interface `AbleRd`
  Overrides:
    `compMinus` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the subtraction operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### compMultiply

    public AbleLiteral compMultiply(AbleRd theRhs)
                             throws AbleDataException

  Compute, multiply the current value of this data object to the current value of theRhs.

  "*" is used for numeric multiplication.

  Specified by:
    `compMultiply` in interface `AbleRd`
  Overrides:
    `compMultiply` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the multiplication operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### compDivide

    public AbleLiteral compDivide(AbleRd theRhs)
                           throws AbleDataException

  Compute, divide the current value of this data object by the current value of theRhs.

  "/" is used for numeric division.

  Specified by:
    `compDivide` in interface `AbleRd`
  Overrides:
    `compDivide` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the division operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### compModulo

    public AbleLiteral compModulo(AbleRd theRhs)
                           throws AbleDataException

  Compute, modulo - divide (without remainder) the current int value of this data object by the current value of theRhs.

  "%" is used for integer division without remainder.

  Specified by:
    `compModulo` in interface `AbleRd`
  Overrides:
    `compModulo` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the division operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### logicalAND

    public boolean logicalAND(AbleRd theRhs)
                       throws AbleDataException

  Logical AND the current value of this data object with the current value of theRhs.

  "&&" is used for boolean AND.

  Specified by:
    `logicalAND` in interface `AbleRd`
  Overrides:
    `logicalAND` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the logical AND operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### logicalOR

    public boolean logicalOR(AbleRd theRhs)
                      throws AbleDataException

  Logical OR the current value of this data object with the current value of theRhs.

  "||" is used for boolean OR.

  Specified by:
    `logicalOR` in interface `AbleRd`
  Overrides:
    `logicalOR` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the logical OR operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### logicalNOT

    public boolean logicalNOT(AbleRd theRhs)
                       throws AbleDataException

  Logical NOT: complement the current value of this data object.

  "!" is used for boolean NOT.

  Specified by:
    `logicalNOT` in interface `AbleRd`
  Overrides:
    `logicalNOT` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the comparison.

  Returns:
    The result of the boolean NOT operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseAND

    public AbleLiteral bitwiseAND(AbleRd theRhs)
                           throws AbleDataException

  Bitwise AND the current value of this data object with the current value of theRhs.

  "&" is used for bitwise AND.

  Specified by:
    `bitwiseAND` in interface `AbleRd`
  Overrides:
    `bitwiseAND` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise AND operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseOR

    public AbleLiteral bitwiseOR(AbleRd theRhs)
                          throws AbleDataException

  Bitwise OR the current value of this data object with the current value of theRhs.

  "|" is used for bitwise OR.

  Specified by:
    `bitwiseOR` in interface `AbleRd`
  Overrides:
    `bitwiseOR` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise OR operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseXOR

    public AbleLiteral bitwiseXOR(AbleRd theRhs)
                           throws AbleDataException

  Bitwise XOR: exclusive OR the current value of this data object with the current value of theRhs.

  "^" is used for bitwise XOR.

  Specified by:
    `bitwiseXOR` in interface `AbleRd`
  Overrides:
    `bitwiseXOR` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise XOR operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseNOT

    public AbleLiteral bitwiseNOT(AbleRd theRhs)
                           throws AbleDataException

  Bitwise NOT: unary complement of the current value of this data object.

  "~" is used for bitwise NOT or complement.

  Specified by:
    `bitwiseNOT` in interface `AbleRd`
  Overrides:
    `bitwiseNOT` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise NOT operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseShiftLeft

    public AbleLiteral bitwiseShiftLeft(AbleRd theRhs)
                                 throws AbleDataException

  Bitwise Shift Left the current value of this data object by the current value of theRhs.

  "&&" is used for boolean AND.

  Specified by:
    `bitwiseShiftLeft` in interface `AbleRd`
  Overrides:
    `bitwiseShiftLeft` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise shift left operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseShiftRight

    public AbleLiteral bitwiseShiftRight(AbleRd theRhs)
                                  throws AbleDataException

  Bitwise Shift Right the current value of this data object by the current value of theRhs.

  ">>" is used for bitwise shift right.

  Specified by:
    `bitwiseShiftRight` in interface `AbleRd`
  Overrides:
    `bitwiseShiftRight` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise shift right operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### bitwiseShiftRightZeroFill

    public AbleLiteral bitwiseShiftRightZeroFill(AbleRd theRhs)
                                          throws AbleDataException

  Bitwise Shift Right with Zero Fill the current value of this data object by the current value of theRhs.

  ">>" is used for bitwise shift right with zero fill.

  Specified by:
    `bitwiseShiftRightZeroFill` in interface `AbleRd`
  Overrides:
    `bitwiseShiftRightZeroFill` in class `AbleLiteral`
  Parameters:
    `theRhs` - The right-hand side of the operation.

  Returns:
    The result of the bitwise shift right with zero fill operation.
  Throws:
    `AbleDataException` - If the right-hand side cannot be converted (if necessary) and compared to this data object.

### getTypedVariable

    public AbleTypedVariable getTypedVariable()

  Retrieve the typed variable

### getReturnType

    public java.lang.Class getReturnType()
                                  throws java.rmi.RemoteException

  Get the data type of the value returned from the associated method invocation.

  Returns:
    The class representing the return type of the method
  Throws:
    `java.rmi.RemoteException`

### traceString

    public java.lang.String traceString(int theTraceStringFlavor)

  Retrieve a string describing (the contents of) the object.

  Specified by:
    `traceString` in interface `AbleRd`
  Specified by:
    `traceString` in class `AbleLiteral`
  Parameters:
    `theTraceStringFlavor` - An Able.TraceStringFlavor value.

  Returns:
    A String containing the current contents of the object.

### trcString

    protected java.lang.String trcString(int theTraceStringFlavor)

### getDataType

    public int getDataType()

  Description copied from class: `AbleLiteral`
  Retrieve the data type of this data object.

  Specified by:
    `getDataType` in interface `AbleRd`
  Specified by:
    `getDataType` in class `AbleLiteral`
  Returns:
    An AbleData.<DataType> constant.
  See Also:
    `AbleRd.getDataType()`

### equals

    public boolean equals(java.lang.Object otherObject)

### getLiterals

    public java.util.Vector getLiterals()

  The list of literals that make up this compound literals

### hashCode

    public int hashCode()

### getVariableReferences

    public java.util.HashSet getVariableReferences()

  Retrieve the set of variables (if any) referenced by this expression (and subexpressions)

### getDataTypeClass

    public java.lang.Class getDataTypeClass()

  Retrieve the Class of the underlying return value; that is, the value returned by last field or method.

  Specified by:
    `getDataTypeClass` in interface `AbleRd`
  Specified by:
    `getDataTypeClass` in class `AbleLiteral`
  Returns:
    The class of the underlying data type.

### getDataTypeClassName

    public java.lang.String getDataTypeClassName()

  Retrieve the Class name of the underlying return value; that is, the value returned by last field or method.

  Specified by:
    `getDataTypeClassName` in interface `AbleRd`
  Specified by:
    `getDataTypeClassName` in class `AbleLiteral`
  Returns:
    A String that is the name of the class of the underlying data type.

### isConstant

    public boolean isConstant()

  Description copied from interface: `AbleRd`
  Returns true if this AbleRd object is a constant value false, if it does not.

  Specified by:
    `isConstant` in interface `AbleRd`
  Overrides:
    `isConstant` in class `AbleLiteral`

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005